Leetcode习题: Two Sum

来源:互联网 发布:知乎国家电网发展 编辑:程序博客网 时间:2024/05/11 19:05

Two Sum

 
AC Rate: 2001/9056
My Submissions

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

思路上三种:

  1. 最直接的,两层遍历,时间复杂度O(n^2)。这样也提交过,可以通过。也许这是online judge最早的题,所以在时间复杂度的检测上不是那么精确吧..
  2. 先排序,再用前后两个指针。时间复杂度O(nlogn+n),故为O(nlogn)。
  3. 哈希。将数组中的每个值放在map中,遍历数组,寻找与其相加为target的数是否存在,若存在则返回结果,题目中也已经说明可以假定一定会存在一组解。
    public int[] twoSum(int[] numbers, int target) {                Map<Integer, Integer> map = new HashMap<Integer, Integer>();        for(int i = 0; i < numbers.length; i++){            map.put(numbers[i], i+1);        }                for(int i = 0; i < numbers.length; i++){            int nextValue = target - numbers[i];            if(map.get(nextValue) != null){                return new int[]{i+1, map.get(nextValue)};            }        }                return null;    }




原创粉丝点击